<?php

namespace Drupal\filefield_embed_html;

use Drupal\Core\Archiver\Zip;

class Unarchiver {

  /**
   * The file to be processed.
   */
  protected $file;

  /**
   * Constructs the HTMLExtractor object.
   */
  public function __construct($file) {
    $this->file = $file;
  }

  /**
   * Gets the file's MIME Type.
   */
  public function getMimeType($file) {
    return mime_content_type($file);
  }

  /**
   * Extracts the archive into a specified destination directory.
   *
   * @param $destination
   *   The destination directory for the file to be extracted to.
   */
  public function extractTo($destination) {
    try {
      switch ($this->getMimeType($this->file)) {
        case 'application/zip':
          $archive = new Zip($this->file);
          $archive->extract($destination);
          break;

        default:
          throw new \Exception('The provided file is not supported. Please use a ZIP archive instead.');
      }
    }
    catch (Exception $e) {
      throw new \Exception($e);
    }
  }

}